<template>
  <div class="col-md-12">
    <div class="card card-container">
      <img
          id="profile-img"
          src="//ssl.gstatic.com/accounts/ui/avatar_2x.png"
          class="profile-img-card"
          alt="profile-img"
      />
      <form name="form" @submit.prevent="handleRegister">
        <div v-if="!successful">
          <div class="form-group">
            <label for="username">Nazwa użytkownika</label>
            <input
                v-model="user.username"
                v-validate="'required|min:3|max:20'"
                type="text"
                class="form-control"
                id="username"
                name="username"
            />
            <div
                v-if="submitted && this.errors.has('username')"
                class="alert-danger"
            >

              <div v-if="this.errors.first('username').toString().includes('The username field must be at least 3')">
                Nazwa użytkownika musi składać się z minimum 3 znaków!
              </div>

              <div v-if="this.errors.first('username').toString().includes('The username field may not be greater than 20 characters')">
                Nazwa użytkownika nie może być dłuższa niż 20 znaków!
              </div>


            </div>
          </div>
          <div class="form-group">
            <label for="password">Hasło</label>
            <input
                id="password"
                v-model="user.password"
                v-validate="'required|min:6|max:40'"
                type="password"
                class="form-control"
                name="password"
            />
            <div
                v-if="submitted && this.errors.has('password')"
                class="alert-danger"
            >
              <div v-if="this.errors.first('password').toString().includes('The password field must be at least 6')">
                Hasło musi składać się z minimum 6 znaków!
              </div>

              <div v-if="this.errors.first('password').toString().includes('The password field may not be greater than 40 characters')">
                Hasło nie może być dłuższe niż 40 znaków!
              </div>

            </div>
          </div>
          <div class="form-group">
            <button class="btn btn-primary btn-block">Zarejestruj</button>
          </div>
        </div>
      </form>

      <div
          v-if="message"
          class="alert"
          :class="successful ? 'alert-success' : 'alert-danger'"
      >{{ message }}
      </div>
    </div>
  </div>
</template>

<script>
import User from '../../models/user';

export default {
  name: 'Register',
  data() {
    return {
      user: new User('', ''),
      submitted: false,
      successful: false,
      message: ''
    };
  },
  computed: {
    loggedIn() {
      return this.$store.state.auth.status.loggedIn;
    }
  },
  mounted() {
    if (this.loggedIn) {
      this.$router.push('/profile');
    }
  },
  methods: {
    handleRegister() {
      this.message = '';
      this.submitted = true;
      this.$validator.validate().then(isValid => {
        if (isValid) {
          this.$store.dispatch('auth/register', this.user).then(
              data => {
                this.message = data.message;

                if (this.message !== "Request failed with status code 409") {

                  this.successful = true;
                  alert('Konto założone poprawnie!')

                  this.$store.dispatch('auth/login', this.user).then(
                      () => {
                        this.$router.push('/profile');
                      },
                      error => {
                        this.loading = false;
                        this.message =
                            (error.response && error.response.data && error.response.data.message) ||
                            error.message ||
                            error.toString();
                      }
                  );
                }

              },
              error => {
                this.message =
                    (error.response && error.response.data && error.response.data.message) ||
                    error.message ||
                    error.toString();
                this.successful = false;

                if (this.message === "Request failed with status code 409") {
                  this.message = "Wybrana nazwa użytkownika jest już zajęta!";
                }
              },
          );
        }
      });
    }
  }
};
</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}

.card-container.card {
  max-width: 350px !important;
  padding: 40px 40px;
}

.card {
  background-color: #f7f7f7;
  padding: 20px 25px 30px;
  margin: 0 auto 25px;
  margin-top: 50px;
  -moz-border-radius: 2px;
  -webkit-border-radius: 2px;
  border-radius: 2px;
  -moz-box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
  -webkit-box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
  box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
}

.profile-img-card {
  width: 96px;
  height: 96px;
  margin: 0 auto 10px;
  display: block;
  -moz-border-radius: 50%;
  -webkit-border-radius: 50%;
  border-radius: 50%;
}
</style>